Index: cpu/x86/pc/elfhdr.fth
===================================================================
--- cpu/x86/pc/elfhdr.fth	(Revision 548)
+++ cpu/x86/pc/elfhdr.fth	(Arbeitskopie)
@@ -19,7 +19,7 @@
    \ we adjust the load-address below at position 0x40
   dropin-base  h# 20 +  l,  \ 0x18 entry point virtual address
 [then]
-[ifdef] qemu-loaded
+[ifdef] linuxbios-loaded
    \ skip OBMD header but keep elf-header because elfboot in LinuxBIOS needs it
    dropin-base h# 20 +  l, \ 0x18 entry point virtual address
 [else]
@@ -34,7 +34,7 @@
 [ifdef] grub-loaded
   1            w,  \ 0x2c program header table entry count (one pheader)
 [then]
-[ifdef] qemu-loaded 
+[ifdef] linuxbios-loaded 
   1            w,  \ 0x2c program header table entry count (one pheader)
 [else]
   0            w,  \ 0x2c program header table entry count (no pheaders)
@@ -50,7 +50,7 @@
   0            l,  \ 0x3c vaddr
 [then]
 
-[ifdef] qemu-loaded \ Pheader causes elfboot to copy us to RAM
+[ifdef] linuxbios-loaded \ Pheader causes elfboot to copy us to RAM
   \ 0x34  Pheader
   1            l,  \ 0x34 entry type PT_LOAD
   0            l,  \ 0x38 file offset
@@ -64,7 +64,7 @@
   dropin-base  h# 14 - l,  \ 0x40 paddr         \ Where to put the bits
 [then]
 
-[ifdef] qemu-loaded
+[ifdef] linuxbios-loaded
   dropin-base h# 80 -  l,  \ 0x40 paddr         \ Where to put the bits
 [else]
   dropin-base  l,  \ 0x40 paddr         \ Where to put the bits
@@ -72,7 +72,7 @@
   h# ffffffff  l,  \ 0x44 file size     \ backpatched later
   h# ffffffff  l,  \ 0x48 memory size   \ backpatched later
 
-[ifndef] qemu-loaded
+[ifndef] linuxbios-loaded
   0            l,
   0            l,
 [then]
Index: cpu/x86/pc/biosload/fw.bth
===================================================================
--- cpu/x86/pc/biosload/fw.bth	(Revision 548)
+++ cpu/x86/pc/biosload/fw.bth	(Arbeitskopie)
@@ -121,6 +121,12 @@
 end-support-package
 [then]
 
+[ifdef] qemu-loaded 
+fload ${BP}/cpu/x86/pc/biosload/lbtable.fth
+fload ${BP}/cpu/x86/pc/biosload/lbcmos.fth
+fload ${BP}/cpu/x86/pc/biosload/lbdevtree.fth
+[then]
+
 support-package: zip-file-system
    fload ${BP}/ofw/fs/zipfs.fth		\ Zip file system
 end-support-package
Index: cpu/x86/pc/biosload/ofw.bth
===================================================================
--- cpu/x86/pc/biosload/ofw.bth	(Revision 548)
+++ cpu/x86/pc/biosload/ofw.bth	(Arbeitskopie)
@@ -46,11 +46,7 @@
   .( --- Saving as ofwlb.elf - LinuxBIOS payload format) cr
   fload ${BP}/cpu/x86/pc/elfhdr.fth
   writing ofwlb.elf
-  [ifdef] qemu-loaded
-    elf-header /elf-header ofd @ fputs
-  [else]
-    elf-header /elf-header  0  " elf-header"  write-dropin
-  [then]
+  elf-header /elf-header ofd @ fputs
 [then]
 
 [ifdef] syslinux-loaded
@@ -123,7 +119,7 @@
    pad 4 ofd @ fputs        \ Patch memory size
 [then]
 
-[ifdef] qemu-loaded
+[ifdef] linuxbios-loaded
    ofd @ fsize pad !        \ file size; store in memory for convenience below
    h# 44 ofd @ fseek        \ Seek to file size field; see elfhdr.bth
    pad 4 ofd @ fputs        \ Patch file size
Index: cpu/x86/pc/biosload/addrs.fth
===================================================================
--- cpu/x86/pc/biosload/addrs.fth	(Revision 548)
+++ cpu/x86/pc/biosload/addrs.fth	(Arbeitskopie)
@@ -8,20 +8,18 @@
 \ early startup code - the first few instructions in the image -
 \ copies it to get it out of the way of things like OS load areas.
 
-[ifdef] linuxbios-loaded
-  [ifdef] qemu-loaded
-    \ when running in qemu OFW is not in ROM but loaded to RAM by elfboot
+  [ifdef] linuxbios-loaded
+    \ when running on top of LinuxBIOS, OFW is not in ROM but loaded to RAM by elfboot
     h# 198.0080 constant dropin-base  \ Location of payload in RAM
     dropin-base h# 20 +  constant ResetBase	\ Location of "reset" dropin in RAM
   [else]
     h# fff8.0000 constant dropin-base  \ Location of payload in FLASH
     dropin-base h# 80 + h# 20 +  constant ResetBase	\ Location of "reset" dropin in ROM
   [then]
-  h#   08.0000 constant dropin-size
-[then]
+  h#   10.0000 constant dropin-size
 
 \needs dropin-base  h# 198.0000 constant dropin-base
-\needs dropin-size  h#   8.0000 constant dropin-size
+\needs dropin-size  h#   10.0000 constant dropin-size
 \needs ResetBase    dropin-base h# 20 +  constant ResetBase	\ Location of "reset" dropin in ROM
 
 \ This is considerably more memory than Open Firmware needs
@@ -31,7 +29,7 @@
 \needs /fw-ram    h#  20.0000 constant /fw-ram
 
 \needs heap-base  h# 1c0.0000 constant heap-base \ Dynamic allocation heap
-\needs heap-size  h#  20.0000 constant heap-size
+\needs heap-size  h#  40.0000 constant heap-size
 
 \needs dma-base   h# 1e0.0000 constant dma-base  \ DMA heap
 \needs dma-size   h#  20.0000 constant dma-size
Index: cpu/x86/pc/resetend.fth
===================================================================
--- cpu/x86/pc/resetend.fth	(Revision 548)
+++ cpu/x86/pc/resetend.fth	(Arbeitskopie)
@@ -4,7 +4,7 @@
    \ The memory layout information from the start dropin is stored in low
    \ memory.
 
-[ifndef] qemu-loaded
+   [ifndef] qemu-loaded
    \ Move GDT to low memory.  We use the first location at gdt-pa as
    \ scratch memory for sgdt, and put the actual gdt at gdt-pa + 0x10
    gdt-pa # ax mov
@@ -42,7 +42,7 @@
    ax fs  mov
    ax gs  mov
    ax ss  mov
-[then]
+  [then]
 
    h# 20 # al mov  al h# 80 # out
 
